/*-----copyright-----
 *     amy-studio - make development easier 
 *     web        : http://www.amy-studio.com
 *     taobao     : http://amy-studio.taobao.com
 *     qq(e_mail) : amystudio@qq.com
 *-----file info-----
 *     name       : vga_test.v
 *     author     : Yuphone Chang
 *     description: test for VGA drive
 *----- version -----
 *     created    : 7.20, 2010
 *     version    : 1.0
 *     description: original version
 *
 *     modified   : 
 *     version    : 
 *     description: 
 *-------------------
 */
 
module vga_test(
  input        CLOCK_50,                // global clock 
  input        Q_KEY,                   // asynchronous reset
  
  output       VGA_HS,                  // Horizontal sync
  output       VGA_VS,                  // Vertical sync
  output       VGA_R,                   // RED 
  output       VGA_G,                   // GREEN 
  output       VGA_B                    // BLUE 
);


//++++++++++++++++++++++++++++++++++++++
// generating the char data begins
//++++++++++++++++++++++++++++++++++++++
wire [9:0] x_pos_buf;
wire [9:0] y_pos_buf;
wire red_buf;
wire green_buf;
wire blue_buf; 
  
disp_char disp_u0(
  .i_clk            (CLOCK_50),
  .i_rst_n          (Q_KEY),
  //
  .i_x_pos          (x_pos_buf),
  .i_y_pos          (y_pos_buf),
  .o_red            (red_buf),
  .o_green          (green_buf),
  .o_blue           (blue_buf) 
);
//--------------------------------------
// generating the char data ends
//--------------------------------------


//++++++++++++++++++++++++++++++++++++++
// Instantiation of VGA drive module begins 
//++++++++++++++++++++++++++++++++++++++
vga_drive vga_u0( 
  .i_clk            (CLOCK_50),
  .i_rst_n          (Q_KEY), 
  //
  .o_x_pos          (x_pos_buf),
  .o_y_pos          (y_pos_buf),
  .i_red            (red_buf),
  .i_green          (green_buf),
  .i_blue           (blue_buf),
  //
  .o_vga_hs         (VGA_HS),
  .o_vga_vs         (VGA_VS),
  .o_vga_r          (VGA_R),
  .o_vga_g          (VGA_G),
  .o_vga_b          (VGA_B)  
);
//-------------------------------------
// Instantiation of VGA drive module ends 
//-------------------------------------

endmodule
