module tlc549(
  input  CLOCK_50, // 50MHzʱ 
  input  RST_N,
  //
  output ADC549_CLK,
  output ADC549_CS_N,
  input ADC549_DATA,
  //
  output [7:0] SEG7_SEG, // ߶ ν              
  output [2:0] SEG7_SEL  // ߶ λ 
);

wire [7:0] ad_data;
tlc549_driver tlc549_driver_inst(
    .CLOCK_50(CLOCK_50),
    .RST_N(RST_N),
    //
    .ad_enable(1'b1),
    .ad_data(ad_data),
    // 
    .nCS(ADC549_CS_N),
    .SCK(ADC549_CLK),
    .SDO(ADC549_DATA)
);

seg7x8_drive seg7x8_driver_inst(
  .i_clk            (CLOCK_50),
  .i_rst_n          (RST_N),
  
  .i_turn_off       (8'b1111_1100), // Ϩλ[2]
  .i_dp             (8'b0000_0000), // Сλ[2]
  .i_data           (ad_data), // [16]
  
  .o_seg            (SEG7_SEG),
  .o_sel            (SEG7_SEL)
);

endmodule
